ODBCAppender Class Reference
Inheritance diagram for ODBCAppender:

## Public Member Functions

| ODBCAppender ()
virtual | ~ODBCAppender ()
virtual void | setOption (const LogString &option, const LogString &value)
| Set options. More...
virtual void | activateOptions (log4cxx::helpers::Pool &p)
| Activate the specified options. More...
void | append (const spi::LoggingEventPtr &event, log4cxx::helpers::Pool &)
| Adds the event to the buffer. More...
virtual void | close ()
| Closes the appender, flushing the buffer first then closing the default connection if it is open. More...
virtual void | flushBuffer (log4cxx::helpers::Pool &p)
| loops through the buffer of LoggingEvents, gets a sql string from getLogStatement() and sends it to execute(). More...
virtual bool | requiresLayout () const
| ODBCAppender requires a layout. More...
void | setSql (const LogString &s)
| Set pre-formated statement eg: insert into LogTable (msg) values ("%m") More...
const LogString & | getSql () const
| Returns pre-formated statement eg: insert into LogTable (msg) values ("%m") More...
void | setUser (const LogString &user)
void | setURL (const LogString &url)
void | setPassword (const LogString &password)
void | setBufferSize (size_t newBufferSize)
const LogString & | getUser () const
const LogString & | getURL () const
const LogString & | getPassword () const
size_t | getBufferSize () const
Public Member Functions inherited from AppenderSkeleton
| AppenderSkeleton ()
| AppenderSkeleton (const LayoutPtr &layout)
void | addRef () const
void | releaseRef () const
void | finalize ()
| Finalize this appender by calling the derived class' `close` method. More...
void | addFilter (const spi::FilterPtr &newFilter)
| Add a filter to end of the filter list. More...
void | clearFilters ()
| Clear the filters chain. More...
const spi::ErrorHandlerPtr & | getErrorHandler () const
| Return the currently set spi::ErrorHandler for this Appender. More...
spi::FilterPtr | getFilter () const
| Returns the head Filter. More...
const spi::FilterPtr & | getFirstFilter () const
| Return the first filter in the filter chain for this Appender. More...
LayoutPtr | getLayout () const
| Returns the layout of this appender. More...
LogString | getName () const
| Returns the name of this Appender. More...
const LevelPtr & | getThreshold ()
| Returns this appenders threshold level. More...
bool | isAsSevereAsThreshold (const LevelPtr &level) const
| Check whether the message level is below the appender's threshold. More...
void | doAppend (const spi::LoggingEventPtr &event, log4cxx::helpers::Pool &pool)
| This method performs threshold checks and invokes filters before delegating actual logging to the subclasses specific AppenderSkeleton::append method. More...
void | setErrorHandler (const spi::ErrorHandlerPtr &eh)
| Set the ErrorHandler for this Appender. More...
void | setLayout (const LayoutPtr &layout1)
| Set the layout for this appender. More...
void | setName (const LogString &name1)
| Set the name of this Appender. More...
void | setThreshold (const LevelPtr &threshold)
| Set the threshold level. More...
Public Member Functions inherited from Appender
virtual | ~Appender ()
Public Member Functions inherited from OptionHandler
virtual | ~OptionHandler ()
Public Member Functions inherited from Object
virtual const helpers::Class & | getClass () const
virtual | ~Object ()
virtual bool | instanceof (const Class &clazz) const =0
virtual const void * | cast (const Class &clazz) const =0
Public Member Functions inherited from ObjectImpl
| ObjectImpl ()
virtual | ~ObjectImpl ()
void | addRef () const
void | releaseRef () const

## Protected Types

typedef void * | SQLHDBC
typedef void * | SQLHENV
typedef void * | SQLHANDLE
typedef short | SQLSMALLINT

## Protected Member Functions

LogString | getLogStatement (const spi::LoggingEventPtr &event, helpers::Pool &p) const
| By default getLogStatement sends the event to the required Layout object. More...
virtual void | execute (const LogString &sql, log4cxx::helpers::Pool &p)
| Override this to provide an alertnate method of getting connections (such as caching). More...
virtual void | closeConnection (SQLHDBC con)
| Override this to return the connection to a pool, or to clean up the resource. More...
virtual SQLHDBC | getConnection (log4cxx::helpers::Pool &p)
| Override this to link with your connection pooling system. More...

## Protected Attributes

LogString | databaseURL
| URL of the DB for default connection handling. More...
LogString | databaseUser
| User to connect as for default connection handling. More...
LogString | databasePassword
| User to use for default connection handling. More...
SQLHDBC | connection
| Connection used by default. More...
SQLHENV | env
LogString | sqlStatement
| Stores the string given to the pattern layout for conversion into a SQL statement, eg: insert into LogTable (Thread, File, Message) values ("%t", "%F", "%m") More...
size_t | bufferSize
| size of LoggingEvent buffer before writing to the database. More...
std::list< spi::LoggingEventPtr > | buffer
| ArrayList holding the buffer of Logging Events. More...
Protected Attributes inherited from AppenderSkeleton
LayoutPtr | layout
| The layout variable does not need to be set if the appender implementation has its own layout. More...
LogString | name
| Appenders are named. More...
LevelPtr | threshold
| There is no level threshold filtering by default. More...
spi::ErrorHandlerPtr | errorHandler
| It is assumed and enforced that errorHandler is never null. More...
spi::FilterPtr | headFilter
| The first filter in the filter chain. More...
spi::FilterPtr | tailFilter
| The last filter in the filter chain. More...
bool | closed
| Is this appender closed? More...
log4cxx::helpers::Pool | pool
log4cxx::helpers::Mutex | mutex
Protected Attributes inherited from ObjectImpl
unsigned int volatile | ref

## Additional Inherited Members

Static Public Member Functions inherited from Object
static const helpers::Class & | getStaticClass ()
static const log4cxx::helpers::ClassRegistration & | registerClass ()

## Detailed Description

WARNING: This version of ODBCAppender is very likely to be completely replaced in the future. Moreoever, it does not log exceptions.

The ODBCAppender provides for sending log events to a database.

Each append call adds to an `ArrayList` buffer. When the buffer is filled each log event is placed in a sql statement (configurable) and executed.

BufferSize, db URL, User, & Password are configurable options in the standard log4j ways.

The `setSql(String sql)` sets the SQL statement to be used for logging – this statement is sent to a `PatternLayout` (either created automaticly by the appender or added by the user). Therefore by default all the conversion patterns in `PatternLayout` can be used inside of the statement. (see the test cases for examples)

Overriding the getLogStatement method allows more explicit control of the statement used for logging.

For use as a base class:

- Override getConnection() to pass any connection you want. Typically this is used to enable application wide connection pooling.

- Override closeConnection – if you override getConnection make sure to implement `closeConnection` to handle the connection you generated. Typically this would return the connection to the pool it came from.

- Override getLogStatement to produce specialized or dynamic statements. The default uses the sql option value.

## Member Typedef Documentation

typedef void* SQLHANDLE

protected

typedef void* SQLHDBC

protected

typedef void* SQLHENV

protected

typedef short SQLSMALLINT

protected

## Constructor & Destructor Documentation

ODBCAppender | ( |  | ) |

virtual ~ODBCAppender | ( |  | ) |

virtual

## Member Function Documentation

virtual void activateOptions | ( | log4cxx::helpers::Pool & | p | ) |

virtual

Activate the specified options.

Reimplemented from AppenderSkeleton.

void append | ( | const spi::LoggingEventPtr & | event,
|  | log4cxx::helpers::Pool & |
| ) |  |

virtual

Adds the event to the buffer.

When full the buffer is flushed.

Implements AppenderSkeleton.

virtual void close | ( |  | ) |

virtual

Closes the appender, flushing the buffer first then closing the default connection if it is open.

Implements Appender.

virtual void closeConnection | ( | SQLHDBC | con | ) |

protected virtual

Override this to return the connection to a pool, or to clean up the resource.

The default behavior holds a single connection open until the appender is closed (typically when garbage collected).

virtual void execute | ( | const LogString & | sql,
|  | log4cxx::helpers::Pool & | p
| ) |  |

protected virtual

Override this to provide an alertnate method of getting connections (such as caching).

One method to fix this is to open connections at the start of flushBuffer() and close them at the end. I use a connection pool outside of ODBCAppender which is accessed in an override of this method.

virtual void flushBuffer | ( | log4cxx::helpers::Pool & | p | ) |

virtual

loops through the buffer of LoggingEvents, gets a sql string from getLogStatement() and sends it to execute().

Errors are sent to the errorHandler.

If a statement fails the LoggingEvent stays in the buffer!

size_t getBufferSize | ( |  | ) | const

inline

virtual SQLHDBC getConnection | ( | log4cxx::helpers::Pool & | p | ) |

protected virtual

Override this to link with your connection pooling system.

By default this creates a single connection which is held open until the object is garbage collected.

LogString getLogStatement | ( | const spi::LoggingEventPtr & | event,
|  | helpers::Pool & | p
| ) |  | const

protected

By default getLogStatement sends the event to the required Layout object.

The layout will format the given pattern into a workable SQL string.

Overriding this provides direct access to the LoggingEvent when constructing the logging statement.

const LogString& getPassword | ( |  | ) | const

inline

const LogString& getSql | ( |  | ) | const

inline

Returns pre-formated statement eg: insert into LogTable (msg) values ("%m")

const LogString& getURL | ( |  | ) | const

inline

const LogString& getUser | ( |  | ) | const

inline

virtual bool requiresLayout | ( |  | ) | const

inline virtual

ODBCAppender requires a layout.

Implements Appender.

void setBufferSize | ( | size_t | newBufferSize | ) |

inline

virtual void setOption | ( | const LogString & | option,
|  | const LogString & | value
| ) |  |

virtual

Set options.

Reimplemented from AppenderSkeleton.

void setPassword | ( | const LogString & | password | ) |

inline

void setSql | ( | const LogString & | s | ) |

Set pre-formated statement eg: insert into LogTable (msg) values ("%m")

void setURL | ( | const LogString & | url | ) |

inline

void setUser | ( | const LogString & | user | ) |

inline

## Member Data Documentation

std::list<spi::LoggingEventPtr> buffer

protected

ArrayList holding the buffer of Logging Events.

size_t bufferSize

protected

size of LoggingEvent buffer before writing to the database.

Default is 1.

SQLHDBC connection

protected

Connection used by default.

The connection is opened the first time it is needed and then held open until the appender is closed (usually at garbage collection). This behavior is best modified by creating a sub-class and overriding the `getConnection` and `closeConnection` methods.

LogString databasePassword

protected

User to use for default connection handling.

LogString databaseURL

protected

URL of the DB for default connection handling.

LogString databaseUser

protected

User to connect as for default connection handling.

SQLHENV env

protected

LogString sqlStatement

protected

Stores the string given to the pattern layout for conversion into a SQL statement, eg: insert into LogTable (Thread, File, Message) values ("%t", "%F", "%m")

Be careful of quotes in your messages!

Also see PatternLayout.

The documentation for this class was generated from the following file:

- odbcappender.h